zoukankan      html  css  js  c++  java
  • Codeforces Round #278 (Div. 1) B. Strip multiset维护DP

    B. Strip

    Time Limit: 20 Sec

    Memory Limit: 256 MB

    题目连接

    http://codeforces.com/contest/487/problem/B

    Description

    Alexandra has a paper strip with n numbers on it. Let's call them ai from left to right.

    Now Alexandra wants to split it into some pieces (possibly 1). For each piece of strip, it must satisfy:

        Each piece should contain at least l numbers.
        The difference between the maximal and the minimal number on the piece should be at most s.

    Please help Alexandra to find the minimal number of pieces meeting the condition above.

    ⋅1. If you touch a buoy before your opponent, you will get one point. For example if your opponent touch the buoy #2 before you after start, he will score one point. So when you touch the buoy #2, you won't get any point. Meanwhile, you cannot touch buoy #3 or any other buoys before touching the buoy #2.

    ⋅2. Ignoring the buoys and relying on dogfighting to get point. If you and your opponent meet in the same position, you can try to fight with your opponent to score one point. For the proposal of game balance, two players are not allowed to fight before buoy #2 is touched by anybody.

    There are three types of players.

    Speeder: As a player specializing in high speed movement, he/she tries to avoid dogfighting while attempting to gain points by touching buoys.
    Fighter: As a player specializing in dogfighting, he/she always tries to fight with the opponent to score points. Since a fighter is slower than a speeder, it's difficult for him/her to score points by touching buoys when the opponent is a speeder.
    All-Rounder: A balanced player between Fighter and Speeder.

    There will be a training match between Asuka (All-Rounder) and Shion (Speeder).
    Since the match is only a training match, the rules are simplified: the game will end after the buoy #1 is touched by anybody. Shion is a speed lover, and his strategy is very simple: touch buoy #2,#3,#4,#1 along the shortest path.

    Asuka is good at dogfighting, so she will always score one point by dogfighting with Shion, and the opponent will be stunned for T seconds after dogfighting. Since Asuka is slower than Shion, she decides to fight with Shion for only one time during the match. It is also assumed that if Asuka and Shion touch the buoy in the same time, the point will be given to Asuka and Asuka could also fight with Shion at the buoy. We assume that in such scenario, the dogfighting must happen after the buoy is touched by Asuka or Shion.

    The speed of Asuka is V1 m/s. The speed of Shion is V2 m/s. Is there any possibility for Asuka to win the match (to have higher score)?

    Input

    The first line contains three space-separated integers n, s, l (1 ≤ n ≤ 105, 0 ≤ s ≤ 109, 1 ≤ l ≤ 105).

    The second line contains n integers ai separated by spaces ( - 109 ≤ ai ≤ 109).

    Output

    Output the minimal number of strip pieces.

    If there are no ways to split the strip, output -1.

    Sample Input

    7 2 2
    1 3 1 2 4 1 2

    Sample Output

    3

    HINT

    题意

    给你n个数,你可以把这些数划分成很多个区间,要求每个区间的长度至少为L,区间内最大值减去最小值至少为S

    问你区间最少划分为多少

    题解:

    就DP,DP啦

    最简单的想法就是DP[i]表示从0-i最少能够划分多少块,那么

    for(int j=i-1;j>=0;j--)

      if(check(j,i-1))

        dp[i]=min(dp[i],dp[j]+1);

    这个是最简单的dp方程,但是,这个无脑转移是N^2的,那么肿么办?

    你可以用线段树优化,也可以用multiset优化一下

    代码

    #include<iostream>
    #include<stdio.h>
    #include<math.h>
    #include<set>
    using namespace std;
    #define maxn 100005
    int a[maxn];
    int dp[maxn];
    const int inf = 1e9;
    multiset<int> Val;
    multiset<int> Dp;
    int main()
    {
        int n,s,l;
        scanf("%d%d%d",&n,&s,&l);
        for(int i=0;i<n;i++)
            scanf("%d",&a[i]);
        for(int i=0;i<=n;i++)
            dp[i]=inf;
        int L = 0;
        for(int i=0;i<l-1;i++)
            Val.insert(a[i]);
        dp[0]=0;
        for(int i=l-1;i<n;i++)
        {
            Dp.insert(dp[i-(l-1)]);
            Val.insert(a[i]);
            while(L<=(i-(l-1))&&(*Val.rbegin()-*Val.begin()>s))
            {
                Val.erase(Val.find(a[L]));
                Dp.erase(Dp.find(dp[L]));
                L++;
            }
            if(!Dp.empty())
                dp[i+1]=(*Dp.begin())+1;
        }
        if(dp[n]>n)printf("-1
    ");
        else printf("%d
    ",dp[n]);
    }
  • 相关阅读:
    CAD图形引擎库VectorDraw
    基于COM的矢量图像控件VectorDraw
    [转]电子表格Spread 7.0线上发布会
    ProEssentials图表教程汇总
    几种JS 引擎介绍(不同浏览器有不同的引擎)
    我的 学习链接
    ExtJS 2.3版 源代码的解析(转)
    javascript调试原理(一)(转)
    使用GoogleCode SVN服务
    javascript调试原理(二) 模拟实现 (转)
  • 原文地址:https://www.cnblogs.com/qscqesze/p/4957170.html
Copyright © 2011-2022 走看看